/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   bastl@server                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _WERKZEUGEVIEW_H_
#define _WERKZEUGEVIEW_H_

#include <qvariant.h>
#include <qpixmap.h>
#include <qdialog.h>

#include <pthread.h>
#include <kprocess.h>

#include "historydoubleinput.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QPushButton;
class QTabWidget;
class QWidget;
class QLabel;
class QLineEdit;
class KDoubleNumInput;
class QFrame;
class QCheckBox;
class KIntNumInput;
class QComboBox;

class WerkzeugeView: public QDialog
	{
	Q_OBJECT
public:
	WerkzeugeView ( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );

	~WerkzeugeView();

	QPushButton *w_abbruch, *w_beenden, *w_speichern, *z_referenz, *nach_unten_1, *nach_oben_1, *drive;
	QTabWidget* w_tab;
	QWidget* form, *verwendung, *einmessen;
	QLabel* textLabel7_3, *textLabel7_2_2, *textLabel2_4_2_2, *textLabel2_4_3_2, *textLabel2_2_2, *textLabel3_2_3, *textLabel2_4_4, *textLabel2_3_2, *textLabel2_7, *textLabel3_2, *tle1, *tle2, *tle3, *tle4, *tle5, *tle6, *textroot, *tle7, *tle8, *tle10, *tle9, *text_vs;
	QLineEdit* werkzeugname;
	HistoryDoubleInput *w_radius, *w_steigung, *w_l3, *w_durchmesser, *w_l2, *w_winkel, *w_modul, *distance;
	QFrame *line2, *line2_2, *line1, *line3, *line4;
	QCheckBox* schlicht, *klein, *seitlich_o, *seitlich_u, *unten_a, *unten_m, *nach_u, *nach_s, *nach_o, *schrup;
	KIntNumInput *differenz_ist, *differenz_soll, *vorschub;
	QComboBox *m_combo, *w_combo;

	QCString wname, sdat, wdat;
	Q_UINT8 b;
	Q_INT16 w, acceleration, mfactor, range_z, max_speed_z;
	QString werkzeuge, maschinendatei;
	KProcess *steuerung;
	volatile int delta;
	volatile bool GESPEICHERT, MESSEN, COMBO, SELECTED, RUN_M, UP_M, CLOSE_M;
	volatile int aW, n, aM;
	uchar statusb;
	pthread_t th_m;
	timespec delay, rest;

	void clearall();
	static void *move_th ( void *parent );

public slots:
	void speichern_cklicked();
	void werkzeugname_changed();
	void beenden_cklicked();
	void w_combo_activated();
	void radius_changed();
	void steigung_changed();
	void modul_changed();
	void winkel_changed();
	void double_ischanged();
	void check_ischanged();
	void referenz_clicked();
	void m_combo_activated();
	void changed();
	void z1_o_pressed();
	void z1_o_released();
	void z1_u_pressed();
	void z1_u_released();
	void drive_cklicked();

private:
	QPixmap image0, image2, image3;

private slots:
	void closeEvent ( QCloseEvent* );

protected:
	QGridLayout *WerkzeugeLayout, *formLayout, *verwendungLayout, *einmessenLayout;

protected slots:
	virtual void languageChange();


	};

#endif // _WERKZEUGEVIEW_H_


